####################
# Optional variables
####################
# INFRA_WORKDIR: defaults to root directory. example build/terraform (don't add trailing slash)
# TF_OUTPUT_TO_MR:  defaults to true; 
# TF_LINT_ALLOW_FAILURE: defaults to false. Set to true to allow the pipeline to continue in the event of a failure (i.e., improperlly formatted files)

.terraform-tflint:
  image:
    name:  elijer50/terraform-ci:latest
    entrypoint: [""]
  before_script:
    - curl --version || apk add curl
  rules:
    - if: '$CI_PIPELINE_SOURCE == "merge_request_event" && $TF_LINT_ALLOW_FAILURE == "true"'
      allow_failure: true
    - if: '$CI_PIPELINE_SOURCE == "merge_request_event"'
      allow_failure: false

  script:
    - 'if [ -z ${INFRA_WORKDIR} ]; then echo "INFRA_WORKDIR not set, running in root directory"; else echo "Running terraform in ${INFRA_WORKDIR} dir"; cd ${INFRA_WORKDIR} ; fi'
    - 'if [ -z ${TF_OUTPUT_TO_MR} ]; then echo "TF_OUTPUT_TO_MR not set, defaulting to true"; export TF_OUTPUT_TO_MR="true"; else echo "Using TF_OUTPUT_TO_MR: ${TF_OUTPUT_TO_MR}"; fi'
    - 'if [ -z ${TF_LINT_ALLOW_FAILURE} ] || [ ${TF_LINT_ALLOW_FAILURE} != "true" ]; then echo "TF_LINT_ALLOW_FAILURE not set or not set to true, defaulting to false"; else echo "Using TF_LINT_ALLOW_FAILURE: ${TF_LINT_ALLOW_FAILURE}"; fi'
    - >-
      if [ -z ${TF_LINT_ARGS} ]; then
        echo "TF_LINT_ARGS not set, using default rule"
        export TF_LINT_ARGS="--enable-rule=terraform_documented_outputs --enable-rule=terraform_unused_declarations --enable-rule=terraform_documented_variables --enable-rule=terraform_typed_variables --enable-rule=terraform_standard_module_structure --enable-rule=terraform_required_version --enable-rule=terraform_required_version --enable-rule=terraform_module_pinned_source  --enable-rule=terraform_naming_convention --enable-plugin=aws"
        echo "Using TF_LINT_ARGS: ${TF_LINT_ARGS}"
      else 
        echo "Using TF_LINT_ARGS: ${TF_LINT_ARGS}"
      fi
    - echo "$(tflint -f json --no-color ${TF_LINT_ARGS} ${INFRA_WORKDIR} 2>&1 | jq)" |  tee tf_lint-output.txt 
    - |
      if [[ ${TF_OUTPUT_TO_MR} == "true" ]]; then
        echo "MR Event Creating Discussion"
        echo "#### tf_lint output:" > ${CI_PROJECT_DIR}/format.txt
        echo \`\`\` >> ${CI_PROJECT_DIR}/format.txt
        if [ -s ${CI_PROJECT_DIR}/tf_lint-output.txt ]; then
          cat ${CI_PROJECT_DIR}/tf_lint-output.txt >> ${CI_PROJECT_DIR}/format.txt          
        else
          echo "No Output Found." >> ${CI_PROJECT_DIR}/format.txt
        fi        
        echo \`\`\` >> ${CI_PROJECT_DIR}/format.txt
        export MESSAGE=$(cat ${CI_PROJECT_DIR}/format.txt)
        curl -X POST -g -H "PRIVATE-TOKEN: ${GITLAB_API_TOKEN}" \
          --data-urlencode "body=${MESSAGE}" \
          "${CI_API_V4_URL}/projects/${CI_PROJECT_ID}/merge_requests/${CI_MERGE_REQUEST_IID}/discussions" \
          | tee -a ${CI_PROJECT_DIR}/discussion.txt
      else
        echo "No output selected"
      fi
    - tflint -f json --no-color ${TF_LINT_ARGS} ${INFRA_WORKDIR} || exit $?

  artifacts:
    paths:
      - format.txt
      - tf_lint-output.txt
    expire_in: 1 week



